#!/usr/bin/python3
# -*- coding: utf-8 -*-

###########################################
#                                         #
#         Graphes : TP exercice 09        #
#                                         #
###########################################

import numpy as np
xxx=0

####################################
''' Graphes non-orientés : exo 9 '''
####################################

# ensemble des sommets
S=[0,1,2,3,4,5,6]
# ensemble des aretes sous forme de matrice
A=[(0,2),(0,3),(1,2),(1,3),(1,4),(2,3),(2,4),(3,5),(5,6)]

# renvoie l'ensemble des sommets et des aretes d'un graphe defini dans un fichier
# entree : -
# sortie : une liste S, une liste de couple A
def lectureGraphe():
   PATH="/chemin/qui/va/bien/"
   file = open(PATH+"CPGE-Info-Graphe-TP-G1.txt", "r")
   line = file.readline()  # debut definition des sommets
   line = file.readline()
   S=line.split(', ')
   A=[]
   line = file.readline()  # debut definition des aretes
   line = file.readline()  
   while line !="" :
      line=line[:-1]    # on retire le "%\n"
      arete = line.split(', ')
      A.append((int(arete[0]),int(arete[1])))
      line = file.readline()
   file.close()
   return S, A

S1, A1 = lectureGraphe()

# renvoie la matrice d'adjacence d'un graphe defini par ses Sommets et ses Aretes
# entree : une liste S de sommet et une matrice A d'aretes (si,sj)
# sortie : une matrice carre symetrique de taille |S|
def matriceAdjacence(S,A):
   M=np.array(np.zeros((len(S),len(S))),int)
   for k in A:
      M[k]=1
      M[(k[1],k[0])]=1
   return M


# renvoie l'existence d'une arete entre i et j
# entree : deux sommets i, j et une matrice d'adjacence M
# sortie : booleen
def existeArete(i,j,M):
   return M[i,j]==1

# renvoie le couple (p,m) : p la longueur de la plus petite chaine entre i et j ; m le nombre de telles chaines
# entree : deux sommets i, j et une matrice d'adjacence M
# sortie : un couple d'entier (p,m)
def existeChaine(i,j,M):
   N=np.copy(M) # a garder
   p=1
   n=len(M)
   while p<n :
      if N[i,j]>0:
         return (p,N[i,j])
      N=np.dot(N,M)
      p+=1
   return (0,0)

# renvoie l'existence d'une unique composante connexe du graphe
# entree : une matrice d'adjacence M
# sortie : booleen
def grapheConnexe(M):
   for i in range(len(M)):
      for j in range(i-1): # la matrice est symetrique !
         if existeChaine(i,j,M)==(0,0):
            return False
         j+=1
   return True

print(grapheConnexe(matriceAdjacence(S1,A1)))

# fin du fichier CPGE-Info-Graphe-TP-exo09.py
