#!/usr/bin/python3
# -*- coding: utf-8 -*-

###########################################
#                                         #
#         Graphes : TP exercice 10        #
#                                         #
###########################################

import numpy as np
xxx=0

###########################################################################
''' Graphes non-orientés pondérés par des poids positifs : exo 10 et 11 '''
###########################################################################

# ensemble des sommets
S=[0,1,2,3,4]
# ensemble des aretes sous forme d'une liste simple
L=[[(1,2),(3,6)],[(2,4),(3,2)],[(3,1),(4,4)],[(4,5)]]
# pour les tests de nombreSommets(), listeSommets() et convertListeMatrice()
L2=[[(1,3),(2,5),(3,1)],[],[(3,4),(4,3)]]
# pour les tests du poids minimal (attention les poids mis sont aleatoires)
P2=[(0,7),(1,4),(2,1),(3,5),(4,float("inf"))]

####################################
## EXO 10 : à l'aide d'une matrice #
####################################

# renvoie le nombre de sommets d'un graphe suppose connexe
# entree : liste simple representant un graphe connexe expl : L=[[(1,3),(2,5),(3,1)],[],[(3,4),(4,3)]]
# sortie : entier
def nombreSommets(L):
   n=len(L) # la taille est au moins celle-ci
   for i in L:
      for a in i:
         if a[0]>=n:
            n=a[0]+1
   return n

print(nombreSommets(L2))

# renvoie la liste des sommets d'un graphe suppose connexe
# entree : liste simple representant un graphe connexe
# sortie : liste de sommets
def listeSommets(L):
   return list(range(nombreSommets(L)))

print(listeSommets(L2))

# renvoie une matrice représentant une liste simple
# entree : une liste simple expl : L=[[(1,3),(2,5),(3,1)],[],[(3,4),(4,3)]]
# sortie : une matrice A expl : A=[(0,1,3),(0,2,5),(0,3,1),(2,3,4),(2,4,3)]
def convertListeMatrice(L):
   A=[]
   i=0
   while i<len(L):
      for a in L[i]:
         A.append((i,a[0],a[1]))
      i+=1
   return A

print(convertListeMatrice(L2))

# renvoie la matrice d'adjacence d'un graphe défini par ses Sommets et ses Aretes
# entree : une liste S de sommets et une matrice A d'aretes (si,sj)
# sortie : une matrice carre symetrique de taille |S|
def matriceAdjacenceP(S,A):
   M=np.array(np.zeros((len(S),len(S))),int)
   for k in A:
      M[k[0],k[1]]=k[2]
      M[(k[1],k[0])]=k[2]
   return M

# renvoie le sommet parmi S qui possède un poids (wi) minimal
# entree : une liste S de sommets et une liste P de couples (sc,wi)
# sortie : un sommet de poids minimal spm appartenant à S
def sommetPoidsMin(S,P):
   mini=float("inf") # a garder
   spm=-1
   for s in S:
      if P[s][1]<mini:
         spm=s
         mini=P[s][1]
   return spm

print(sommetPoidsMin(listeSommets(L2),P2))

# effectue l'algorithme de Dijkstra à l'aide de matrice
#    et renvoie une chaine de poids minimale entre les sommets ini et fin
# entree : deux sommets ini, fin et une liste simple L representant un graphe
# sortie : une liste de sommets et un entier
def diskstraMat(ini,fin,L):
   n=nombreSommets(L)
   S=listeSommets(L)
   A=convertListeMatrice(L)
   M=matriceAdjacenceP(S,A)
   P=[]
   result = [fin]
   for s in S:
      P.append((s,float("inf"))) # a l'initialisation, seul le poids est important 
   P[ini]=(ini,0)
   sc=ini   # sommet courant
   while sc != fin :
   # calcul des nouveaux poids
      for i in S: 
         if M[sc,i] != 0:  # existence d'une arete
            if P[sc][1]+M[sc,i]<P[i][1]:
               P[i]=(sc,P[sc][1]+M[sc,i])   # sauvegarde du meilleur chemin
      S.remove(sc)
      sc=sommetPoidsMin(S,P)   # nouveau sommet courant
   while result[-1]!=ini :    # on remonte le meilleur chemin
      result.append(P[result[-1]][0])
   return (P[sc][1],result)

# pour tester si les sommets sont connexes (avec la fonction existechaine() exo 9)
print(existeChaine(6,7,matriceAdjacenceP(listeSommets(L3),convertListeMatrice(L3))))
print(diskstraMat(0,4,L3)) # Asuncion-Caracas
print(diskstraMat(3,7,L3)) # Buenos Aires-Quito
print(diskstraMat(6,7,L3)) # Montevideo-Quito

# Graphe d'un réseau de transport entre plusieurs capitales sud américaines : (capitales, heure)
L3=[[(3,14),(6,16),(8,27),(9,22)],[(4,24),(5,48),(7,21)],[(4,78),(6,34),(9,36)],[(6,5),(8,16)],[(7,42)],[(7,29),(8,40),(9,33)],[],[],[(9,28)]]

# fin du fichier CPGE-Info-Graphe-TP-exo10-corrige.py
