#!/usr/bin/python3
# -*- coding: utf-8 -*-

###########################################
#                                         #
#         Graphes : TP exercice 11        #
#                                         #
###########################################

import numpy as np
xxx=0

###########################################################################
''' Graphes non-orientés pondérés par des poids positifs : exo 10 et 11 '''
###########################################################################

# ensemble des sommets
S=[0,1,2,3,4]
# ensemble des aretes sous forme d'une liste simple
L=[[(1,2),(3,6)],[(2,4),(3,2)],[(3,1),(4,4)],[(4,5)]]
# pour les tests de nombreSommets(), listeSommets() et convertListeMatrice()
L2=[[(1,3),(2,5),(3,1)],[],[(3,4),(4,3)]]
# pour les tests du poids minimal (attention les poids mis sont aleatoires)
P2=[(0,7),(1,4),(2,1),(3,5),(4,float("inf"))]

################################
## EXO 11 : à l'aide de listes #
################################

# renvoie une liste simple sous forme d'une liste de taille n=|S|
# entree : une liste simple expl : L=[[(1,3),(2,5)],[(2,4)]]
# sortie : une liste completee expl : L=[[(1,3),(2,5)],[(2,4)],[]]
def convertListeCompletee(L):
   n=len(L) # futur nombre des sommets
   result=[]
   i=0
   while i<len(L):
      for k in L[i]:
         n=max(n,k[0]+1)
      result.append(L[i])
      i+=1
   while i<n:
      result.append([])
      i+=1
   return result

L2c = convertListeCompletee(L2)
print(L2c)

# renvoie toutes les aretes dont le sommet s est un sommet sous la forme (si,pi)
# entree : un sommet s et une liste completee
# sortie : une liste de couple (sj,pj)
def areteSommetP(s,L):
   result=[]
   i=0
   while i<len(L):
      if L[i] !=[]:
         if i==s:
            for k in L[i]:
               result.append(k)
         else :
            for k in L[i]:
               if k[0]==s:
                  result.append((i,k[1]))
      i+=1
   return result

print(areteSommetP(2,L2c))

# renvoie une liste sans arete relie au sommet s dans l'ensemble fourni
# entree : un sommet s et une liste de couples (si,pi)
# sortie : une liste de couples (si,pi)
def retireSommetLigneP(s,ligne):
   result=[]
   for k in ligne:
      if k[0]!=s:
         result.append(k)
   return result

print(retireSommetLigneP(1,areteSommetP(2,L2c)))

# renvoie une liste completee sans aucune arete reliee au sommet s
# entree : un sommet s et une liste completee
# sortie : une liste completee
def retireSommetListeP(s,L):
   result=len(L)*[[]]   # par defaut une liste completee
   i=0
   while i<len(L):
      if i!=s:
         result[i]=retireSommetLigneP(s,L[i])
      i+=1
   return result

print(retireSommetListeP(2,L2c))

# renvoie le sommet parmi S qui possède un poids (wi) minimal
# entree : une liste S de sommets et une liste P de couples (sc,wi)
# sortie : un sommet de poids minimal spm appartenant à S
def sommetPoidsMin(S,P):      # fonction definie dans l'exo10
   mini=float("inf") # a garder
   spm=-1
   for s in S:
      if P[s][1]<mini:
         spm=s
         mini=P[s][1]
   return spm

# fonction recursive qui implemente l'algorithme de Dijkstra, renvoie un sous-graphe minimal
# entree : deux sommets sc et fin, une liste completee L, une liste S de sommets, une liste P de couples sommet-poids
# sortie : une liste de couples representant un sous-graphe minimal
def diskstraR(sc,fin,L,S,P): # sc pourra etre le pivot de l'etape
   if sc==-1:
      return [] # graphe non connexe
   elif sc==fin:
      return P
   else :
      listaret=areteSommetP(sc,L)
      for i in listaret:
         if P[sc][1]+i[1]<P[i[0]][1]:
            P[i[0]]=(sc,P[sc][1]+i[1])
      L=retireSommetListeP(sc,L)
      S.remove(sc)
      sc=sommetPoidsMin(S,P)
      return diskstraR(sc,fin,L,S,P)

# fonction qui effectue l'appel principal de fonctions recursives pour l'algorithme de Dijkstra à l'aide de liste
#     renvoie une chaine de poids minimale entre les sommets ini et fin
# entree : deux sommets ini, fin et une liste simple L representant un graphe
# sortie : un entier et une liste de sommets
def diskstraRinit(ini,fin,L):
   LC=convertListeCompletee(L)
   S=list(range(len(LC)))
   P=[(-1,float("inf")) for i in range(len(LC))]
   P[ini]=(-1,0)
   P=diskstraR(ini,fin,LC,S,P)   # chaine de poids minimal depuis ini -> fin ; 
   if P==[]:
      print("graphe non connexe")
      return -1,[]
   result=[fin]
   i=fin
   while i!=ini:
      i=P[i][0]
      result.append(i)
   return P[fin][1], result

print(diskstraRinit(0,9,L4))
#print(diskstraMat(0,9,L4)) # ne fonctionne que si les sommets sont reliables

print(diskstraRinit(11,18,L4))# Lisbonne-Prague
print(diskstraRinit(1,16,L4)) # Athènes-Oslo

# Graphe d'un réseau de transport entre plusieurs capitales européennes : (capitales, heure)
L4=[[(12, 7), (5, 3)], [(20, 16), (6, 14)], [(7, 4), (21, 4)], [(24, 7), (18, 4), (17, 11), (0, 7)], [(17, 6), (13, 5)], [(17, 4)], [(10, 12)], [(21, 8)], [(7, 15)], [(16, 18)], [(23, 9), (15, 10)], [(14, 6), (17, 17)], [(17, 6)], [(5, 2), (17, 4)], [(19, 19), (4, 15), (17, 12)], [(9, 14)], [(3, 12), (0, 15)], [], [(0, 9), (13, 7), (17, 11), (24, 4)], [(17, 15), (4, 10), (1, 21), (20, 14), (24, 11)], [(6, 13), (24, 8)], [], [(8, 7)], [(3, 6), (15, 16), (9, 16)], [(17, 13)], [(8, 18), (2, 4)]]

# fin du fichier CPGE-Info-Graphe-TP-exo11-corrige.py
